/******************************************************************************
 *
 * Sugar for Java 1.2.0
 * Copyright (C) 2001-2004  Dipl.-Inf. (FH) Johann Nepomuk Loefflmann,
 * All Rights Reserved, http://www.jonelo.de
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * @author jonelo@jonelo.de
 *
 *****************************************************************************/
package jonelo.sugar.gui;

import javax.swing.ImageIcon;

public class AboutDialog extends javax.swing.JDialog {

    public static String OK = "OK",
            THANKS = "Thanks",
            LICENSE = "License",
            COPYRIGHT = "Copyright",
            ABOUT = "About";            
    

    /** Creates new form AboutDialog */
    public AboutDialog(java.awt.Frame parent, boolean modal) {
        super(parent, modal);
        this.setVisible(false);
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        mainPanel = new javax.swing.JPanel();
        myTabbedPane = new javax.swing.JTabbedPane();
        aboutPanel = new javax.swing.JPanel();
        jPanel1 = new javax.swing.JPanel();
        jPanel3 = new javax.swing.JPanel();
        imageLabel = new javax.swing.JLabel();
        licensePanel = new javax.swing.JPanel();
        jScrollPane1 = new javax.swing.JScrollPane();
        licenseEditorPane = new javax.swing.JEditorPane();
        try {
            licenseEditorPane.setContentType("text/html");
            licenseEditorPane.setText(license);
        } catch (Exception e) {}
        copyrightPanel = new javax.swing.JPanel();
        jScrollPane4 = new javax.swing.JScrollPane();
        copyrightEditorPane = new javax.swing.JEditorPane();
        try {
            //copyrightEditorPane.setContentType("text/html");
            copyrightEditorPane.setText(copyright);
        } catch (Exception e) {}
        thanksPanel = new javax.swing.JPanel();
        jScrollPane2 = new javax.swing.JScrollPane();
        thanksEditorPane = new javax.swing.JEditorPane();
        try {
            thanksEditorPane.setContentType("text/html");
            thanksEditorPane.setText(thanks);
        } catch (Exception e) { System.err.println(e); }
        syspropsPanel = new javax.swing.JPanel();
        jScrollPane3 = new javax.swing.JScrollPane();
        sysPropsTextArea = new javax.swing.JTextArea();
        try {
            sysPropsTextArea.setText(sysProps);
        } catch (Exception e) { System.err.println(e); }
        okPanel = new javax.swing.JPanel();
        okButton = new javax.swing.JButton();

        setCursor(new java.awt.Cursor(java.awt.Cursor.DEFAULT_CURSOR));
        setModal(true);
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                closeDialog(evt);
            }
        });

        mainPanel.setLayout(new java.awt.BorderLayout());

        aboutPanel.setBorder(javax.swing.BorderFactory.createEmptyBorder(10, 10, 10, 10));
        aboutPanel.setLayout(new java.awt.BorderLayout());

        jPanel1.setLayout(new java.awt.BorderLayout());

        jPanel3.setLayout(new java.awt.BorderLayout());

        imageLabel.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        imageLabel.setIcon(icon);
        imageLabel.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        imageLabel.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                imageLabelMouseClicked(evt);
            }
        });
        jPanel3.add(imageLabel, java.awt.BorderLayout.CENTER);

        jPanel1.add(jPanel3, java.awt.BorderLayout.CENTER);

        aboutPanel.add(jPanel1, java.awt.BorderLayout.CENTER);

        myTabbedPane.addTab("About", null, aboutPanel, "");

        licensePanel.setBorder(javax.swing.BorderFactory.createEmptyBorder(10, 10, 10, 10));
        licensePanel.setLayout(new java.awt.BorderLayout());

        jScrollPane1.setFont(new java.awt.Font("Dialog", 0, 10)); // NOI18N
        jScrollPane1.setMinimumSize(new java.awt.Dimension(390, 400));
        jScrollPane1.setPreferredSize(new java.awt.Dimension(390, 400));

        licenseEditorPane.setEditable(false);
        jScrollPane1.setViewportView(licenseEditorPane);

        licensePanel.add(jScrollPane1, java.awt.BorderLayout.CENTER);

        myTabbedPane.addTab("License", licensePanel);

        copyrightPanel.setBorder(javax.swing.BorderFactory.createEmptyBorder(10, 10, 10, 10));
        copyrightPanel.setLayout(new java.awt.BorderLayout());

        jScrollPane4.setPreferredSize(new java.awt.Dimension(390, 400));

        copyrightEditorPane.setEditable(false);
        copyrightEditorPane.setFont(new java.awt.Font("Monospaced", 0, 13)); // NOI18N
        jScrollPane4.setViewportView(copyrightEditorPane);

        copyrightPanel.add(jScrollPane4, java.awt.BorderLayout.CENTER);

        myTabbedPane.addTab("Copyright", copyrightPanel);

        thanksPanel.setBorder(javax.swing.BorderFactory.createEmptyBorder(10, 10, 10, 10));
        thanksPanel.setLayout(new java.awt.BorderLayout());

        jScrollPane2.setFont(new java.awt.Font("Dialog", 0, 10)); // NOI18N
        jScrollPane2.setMinimumSize(new java.awt.Dimension(390, 400));
        jScrollPane2.setPreferredSize(new java.awt.Dimension(390, 400));

        thanksEditorPane.setEditable(false);
        jScrollPane2.setViewportView(thanksEditorPane);

        thanksPanel.add(jScrollPane2, java.awt.BorderLayout.CENTER);

        myTabbedPane.addTab("Thanks", thanksPanel);

        syspropsPanel.setBorder(javax.swing.BorderFactory.createEmptyBorder(10, 10, 10, 10));
        syspropsPanel.setLayout(new java.awt.BorderLayout());

        sysPropsTextArea.setColumns(20);
        sysPropsTextArea.setEditable(false);
        sysPropsTextArea.setRows(5);
        jScrollPane3.setViewportView(sysPropsTextArea);

        syspropsPanel.add(jScrollPane3, java.awt.BorderLayout.CENTER);

        myTabbedPane.addTab("System Properties", syspropsPanel);

        mainPanel.add(myTabbedPane, java.awt.BorderLayout.CENTER);

        getContentPane().add(mainPanel, java.awt.BorderLayout.CENTER);

        okPanel.setLayout(new java.awt.BorderLayout());

        okButton.setText("Ok");
        okButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                okButtonActionPerformed(evt);
            }
        });
        okPanel.add(okButton, java.awt.BorderLayout.CENTER);

        getContentPane().add(okPanel, java.awt.BorderLayout.SOUTH);

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void imageLabelMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_imageLabelMouseClicked
        // Add your handling code here:
        myTabbedPane.setSelectedIndex(1);
    }//GEN-LAST:event_imageLabelMouseClicked

    private void okButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_okButtonActionPerformed
        // Add your handling code here:
        setVisible(false);
        dispose();
    }//GEN-LAST:event_okButtonActionPerformed

    /** Closes the dialog */
    private void closeDialog(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_closeDialog
        setVisible(false);
        dispose();
    }//GEN-LAST:event_closeDialog

    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        new AboutDialog(new javax.swing.JFrame(), false).setVisible(true);
    }

    public void setAboutTab(String s) {
        this.titleAbout = s;
    }

    public void setLicenseTab(String s) {
        this.titleLicense = s;
    }

    public void setLicense(String s) {
        this.license = s;
    }

    public void setThanks(String s) {
        this.thanks = s;
    }

    public void setIcon(ImageIcon icon) {
        this.icon = icon;
    }

    public void setThanksTab(String s) {
        this.titleThanks = s;
    }

    public void setSysPropsTab(String s) {
        this.titleSysProps = s;
    }

    public void setSysProps(String s) {
        this.sysProps = s;
    }

    public void create() {
        initComponents();

        myTabbedPane.setTitleAt(0, titleAbout);
        
        myTabbedPane.setTitleAt(1, titleLicense);
        licenseEditorPane.setCaretPosition(0);
        
        myTabbedPane.setTitleAt(2, titleCopyright);
        copyrightEditorPane.setCaretPosition(0);

        myTabbedPane.setTitleAt(3, titleThanks);
        thanksEditorPane.setCaretPosition(0);

        myTabbedPane.setTitleAt(4, titleSysProps);
        sysPropsTextArea.setCaretPosition(0);
    }
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JPanel aboutPanel;
    private javax.swing.JEditorPane copyrightEditorPane;
    private javax.swing.JPanel copyrightPanel;
    private javax.swing.JLabel imageLabel;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel3;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JScrollPane jScrollPane2;
    private javax.swing.JScrollPane jScrollPane3;
    private javax.swing.JScrollPane jScrollPane4;
    private javax.swing.JEditorPane licenseEditorPane;
    private javax.swing.JPanel licensePanel;
    private javax.swing.JPanel mainPanel;
    private javax.swing.JTabbedPane myTabbedPane;
    private javax.swing.JButton okButton;
    private javax.swing.JPanel okPanel;
    private javax.swing.JTextArea sysPropsTextArea;
    private javax.swing.JPanel syspropsPanel;
    private javax.swing.JEditorPane thanksEditorPane;
    private javax.swing.JPanel thanksPanel;
    // End of variables declaration//GEN-END:variables
    private ImageIcon icon;
    private String license;
    private String titleLicense;
    private String titleAbout;
    private String titleCopyright;
    private String copyright;
    private String titleThanks;
    private String titleSysProps;
    private String thanks;
    private String sysProps;

    /**
     * @return the titleCopyright
     */
    public String getTitleCopyright() {
        return titleCopyright;
    }

    /**
     * @param titleCopyright the titleCopyright to set
     */
    public void setTitleCopyright(String titleCopyright) {
        this.titleCopyright = titleCopyright;
    }
    
    public void setCopyrightTab(String s) {
        this.titleCopyright = s;
    }

    public void setCopyright(String s) {
        this.copyright = s;
    }
    
}
